Bug 1029826 - AFR : getfattr on a file which is in data split-brain fails
AFR : getfattr on a file which is in data split-brain fails
Status: CLOSED CURRENTRELEASE
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: replicate (Show other bugs)
2.1
Unspecified Unspecified
unspecified Severity high
: ---
: ---
Assigned To: Anuradha
storage-qa-internal@redhat.com
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-13 05:16 EST by spandura
Modified: 2016-09-19 22:01 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-08-26 17:58:19 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description spandura 2013-11-13 05:16:38 EST
Description of problem:
======================
Getting the extended attributes of a file which is in data-split-brain state gives "Input/Output" error whereas Setting the extended attributes on a file which is in data-split-brain state is still allowed. 

Version-Release number of selected component (if applicable):
==============================================================
glusterfs 3.4.0.35.1u2rhs built on Oct 21 2013 14:00:58

How reproducible:
==================
Often

Steps to Reproduce:
===================
1.Create 1 x 3 replicate volume. Set self-heal-daemon to off. Start the volume

2.Create 2 fuse mounts. 

3.From one mount point create a file : " dd if=/dev/urandom of=./test_file bs=1M count=1"

4. Bring down brick1 and brick2

5. From mount1 write data to "test_file": " dd if=/dev/urandom of=./test_file bs=2M count=1"

6. Bring back brick1 . Bring down brick3

7. From mount2 write data to "test_file" : " dd if=/dev/urandom of=./test_file bs=3M count=1"

8. Bring back brick2. Bring down brick1

9. From mount2 write data to "test_file" : " dd if=/dev/urandom of=./test_file bs=4M count=1"

10. Bring back brick1 and brick3. 

Note: At this state the file is in split-brain state.

11. From mount point set an extended attribute on the "test_file" {Successful}

12. From mount point get the extended attribute on the "test_file"

Actual results:
================
getfattr fails with Input/output error.

[2013-11-12 10:29:36.865710] W [fuse-bridge.c:4160:fuse_xattr_cbk] 0-glusterfs-fuse: 100: GETXATTR((null)) /test_file
 => -1 (Input/output error)

Expected results:
=================
TBD

Additional info:
=================
Following are the operations that are allowed on the file which are in data-split-brain state

    creating hardlinks
    creating symlinks
    mv
    setfattr
    chmod
    chown
    ls
    stat
    touch

Following are the operations that are not allowed on the file which are in data-split-brain state

    Any writes (truncate, dd, echo, cp etc)
    cat
    getfattr
Comment 2 Pranith Kumar K 2015-08-26 17:58:19 EDT
As per the discussions with Shruti, from Everglades onwards we are failing both data/metadata operations on a file if any split-brain is present.

Note You need to log in before you can comment on or make changes to this bug.